/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_cycle_handler.c
 *
 *	@brief	Windows iTRONT[rXR[ (nh).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_cycle_handler.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR		*ObjList;		//!< nhXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	nh̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitCycleHadler( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	nh̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitCycleHadler( void )
{
	WIHDR		*next_ptr;
	WICYCOBJ	*p = (WICYCOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! nhIuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̎nhIuWFNg\̂o.
		p = (WICYCOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	nh`.
 *
 *	@param	[in]	no		nhԍ.
 *	@param	[in]	obj		nhIuWFNg\̂̃|C^.
 *	@param	[in]	ovr		TRUE = o^ςIDɏ㏑.
 *
 *	@retval	G[R[h.
 */
ER		wi_DefineCycleHadler( INT no, const WICYCOBJ *obj, BOOL ovr )
{
	ER			ercd;
	WICYCOBJ	*p;

	p = (WICYCOBJ *)wi_GetObject( no, ObjList );
	if( p ){
		//! o^ς݃nhɏ㏑֎~̏ꍇ̓G[Iɂ.
		if( !ovr ){
			return E_OBJ;
		}
		//! ɓo^Ănhԍ̏ꍇ͓o^㏑.
		p->Hdr.Id    = no;
		p->Attribute = obj->Attribute;
		p->CycAdr    = obj->CycAdr;
		p->Active    = obj->Active;
		p->ExtInfo   = obj->ExtInfo;
		p->CycleTime = obj->CycleTime;
		p->StartTime = wi_GetSystemTime();
		return E_OK;
	}
	//! nhIuWFNg쐬.
	p = (WICYCOBJ *)wi_CreateObject( no, TMAX_MAXCYC, sizeof(WICYCOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɎnhǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	nh̍폜.
 *
 *	@param	[in]	no		nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteCycleHadler( INT no )
{
	ER			ercd;
	WICYCOBJ	*p;

	//! nhԍ̃IuWFNg擾.
	p = (WICYCOBJ *)wi_FindObject( no, TMAX_MAXCYC, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgYnh菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! nhIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	nh̊.
 *
 *	@param	[in]	no		nhԍ.
 *	@param	[in]	act		TRUE = N / FALSE = ~.
 *	@param	[in]	init	TRUE = v.
 *
 *	@retval	G[R[h.
 */
ER		wi_ActionCycleHadler( INT no, BOOL act, BOOL init )
{
	ER			ercd;
	WICYCOBJ	*p;

	//! nhԍ̃IuWFNg擾.
	p = (WICYCOBJ *)wi_FindObject( no, TMAX_MAXCYC, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! nh̊Zbg.
	p->Active = act;

	//! JE^.
	if( init ){
		p->StartTime = wi_GetSystemTime();
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	nh̏ԎQ.
 *
 *	@param	[in]	no		nhԍ.
 *	@param	[out]	sts		nhԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceCycleHadler( INT no, WICYCSTAT *sts )
{
	ER			ercd;
	WICYCOBJ	*p;
	DWORDLONG	now_time;

	//! nhԍ̃IuWFNg擾.
	p = (WICYCOBJ *)wi_FindObject( no, TMAX_MAXCYC, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! ݎ擾.
	now_time = wi_GetSystemTime();

	//! N܂ł̎ԂvZ.
	if( (now_time - p->StartTime) >= p->CycleTime ){
		sts->LeftTime = 0;
	}else{
		sts->LeftTime = p->CycleTime - (now_time - p->StartTime);
	}
	//! nh̏Ԃ\̂ɃZbg.
	sts->Active  = p->Active;
	sts->ExtInfo = p->ExtInfo;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	nh̃^C}.
 *
 *	@param	[in]	now_time	ݎ.
 *
 *	@retval	Ȃ.
 */
void	wi_CycleTimer( DWORDLONG now_time )
{
	WICYCOBJ *p = (WICYCOBJ *)ObjList;

	while( p ){
		if( p->Active ){
			//! JE^Ԍo߂ǂ`FbN.
			if( (now_time - p->StartTime) >= p->CycleTime ){

				//! nhĂяo.
				if( p->CycAdr ){
					p->CycAdr();
				}
				//! nhĂяoۑ.
				p->StartTime = now_time;
			}
		}
		//! Xg玟̎nho.
		p = (WICYCOBJ *)(p->Hdr.Next);
	}
}

/* End of file */
