/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_fixed_mempool.c
 *
 *	@brief	Windows iTRONT[rXR[ (Œ蒷v[).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_fixed_mempool.h"

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static BYTE	*GetFreeMem( WIMPFOBJ *mpf, INT tskid );
static void	ReleaseFreeMem( WIMPFOBJ *mpf, WIHDR* blk );
static void	MemAllocWaitTask( WIMPFOBJ *mpf );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;			//!< Œ蒷v[Xg̃|C^.

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitFixedMemPool( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitFixedMemPool( void )
{
	WIHDR		*next_ptr;
	WIMPFOBJ	*p = (WIMPFOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! obt@.
		SAFE_RELEASE( p->MemBuf );

		//! Œ蒷v[IuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃v[IuWFNg\̂o.
		p = (WIMPFOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̐.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[in]	obj		v[IuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateFixedMemPool( INT id, const WIMPFOBJ *obj )
{
	INT			i;
	DWORD		size;
	WIHDR		*ptr;
	ER			ercd;
	WIMPFOBJ	*p;

	//! Œ蒷v[IuWFNg쐬.
	p = (WIMPFOBJ *)wi_CreateObject( id, TMAX_MAXMPF, sizeof(WIMPFOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( obj->BlockCnt <= 0 || obj->BlockSize <= 0 ){
		return E_PAR;
	}
	//! ubN1ubÑTCYvZ.
	size = obj->BlockSize + sizeof(WIHDR);

	//! v[̃obt@mۂ.
	p->MemBuf = (BYTE*)malloc( obj->BlockCnt * size );
	if( !p->MemBuf ){
		SAFE_RELEASE( p );
		return E_NOMEM;
	}
	//! mۂobt@NA.
	memset( p->MemBuf, 0, obj->BlockCnt * size );

	//! gpubNL[Ƀobt@o^.
	ptr = (WIHDR *)(p->MemBuf);
	for( i = 0; i < obj->BlockCnt - 1; i++ ){
		ptr->Next = (WIHDR *)((DWORD)ptr + size);
		ptr       = (WIHDR *)((DWORD)ptr + size);
	}
	p->FreeQue = (WIHDR *)(p->MemBuf);
	p->UsedQue = NULL;
	p->WaitQue = NULL;

	//! XgɌŒ蒷v[ǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̍폜.
 *
 *	@param	[in]	id		v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteFixedMemPool( INT id )
{
	ER			ercd;
	WIMPFOBJ	*p;

	//! v[ID̃IuWFNg擾.
	p = (WIMPFOBJ *)wi_FindObject( id, TMAX_MAXMPF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgY郁v[菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! v[̃obt@.
	SAFE_RELEASE( p->MemBuf );

	//! Œ蒷v[IuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[out]	buf		ubÑAhXi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_GetFixedMemPool( INT id, VP buf, TMO tmout )
{
	ER			ercd;
	WIMPFOBJ	*p;
	WITSKOBJ	*tsk;
	BYTE		*blk;

	//! v[ID̃IuWFNg擾.
	p = (WIMPFOBJ *)wi_FindObject( id, TMAX_MAXMPF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !buf ){
		return E_PAR;
	}
	//! ^XNȊǑĂяȍꍇ̓G[ɂ.
	tsk = wi_GetTaskObject( TSK_SELF );
	if( !tsk ){
		return E_CTX;
	}
	//! gp̃ubN擾.
	blk = GetFreeMem( p, tsk->Hdr.Id );

	//! gp̃ubNȂꍇAubNԋp܂Ń^XNX[v.
	if( !blk ){
		ercd = wi_TaskWait( id, TTW_MPF, tmout, p->Attribute, &(p->WaitQue) );
		if( ercd != E_OK ){
			return ercd;
		}
		blk = tsk->Param[0];
	}
	//! ݂oubN烊Nwb_폜.
	*((DWORD *)buf) = (DWORD)blk;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̕ԋp.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[in]	buf		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReleaseFixedMemPool( INT id, VP buf )
{
	ER			ercd;
	WIMPFOBJ	*p;
	WIHDR		*blk,*ptr;

	//! v[ID̃IuWFNg擾.
	p = (WIMPFOBJ *)wi_FindObject( id, TMAX_MAXMPF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !buf ){
		return E_PAR;
	}
	//! ԋpꂽAhX烁ubÑwb_̃AhXvZ.
	blk = (WIHDR *)((DWORD)buf - sizeof(WIHDR) );

	//! ݂oubNL[ɕԋpꂽubN邩ǂ𒲂ׂ.
	for( ptr = p->UsedQue; ptr && ptr != blk; ptr = ptr->Next ) ;
	if( !ptr ){
		return E_OBJ;
	}
	//! ԋpꂽubN.
	ReleaseFreeMem( p, blk );

	//! ubNl҂̃^XNꍇAubN݂oă^XNN.
	MemAllocWaitTask( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̎Q.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[out]	sts		v[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceFixedMemPool( INT id, WIMPFSTAT *sts )
{
	ER			ercd;
	WIMPFOBJ	*p;
	WIHDR		*ptr;
	INT			cnt;

	//! v[ID̃IuWFNg擾.
	p = (WIMPFOBJ *)wi_FindObject( id, TMAX_MAXMPF, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! gp̃ubNJEg.
	cnt = 0;
	ptr = p->FreeQue;
	while( ptr ){
		ptr = ptr->Next;
		cnt++;
	}
	//! Œ蒷v[̏Ԃ\̂ɃZbg.
	sts->WaitId    = wi_GetWaitTaskListFirstId( p->WaitQue );
	sts->FreeBlock = cnt;
	sts->ExtInfo   = p->ExtInfo;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XNmۂubN.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseFixedMemPool( INT id )
{
	WIHDR		*ptr;
	WIMPFOBJ	*p = (WIMPFOBJ *)ObjList;

	while( p ){
		//! ݂oubNL[ɍ폜^XNɑ݂o邩ǂ𒲂ׂ.
		ptr = p->UsedQue;
		while( ptr ){
			WIHDR *next_ptr;
			next_ptr = ptr->Next;

			//! ݂oꍇA݂o.
			if( ptr->Id == id ){
				ReleaseFreeMem( p, ptr );
			}
			ptr = next_ptr;
		}
		//! ҂s񂩂ł^XN폜.
		if( p->WaitQue ){
			p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );
		}
		//! ubNl҂̃^XNꍇAubN݂oă^XNN.
		MemAllocWaitTask( p );

		//! ̃v[\̂o.
		p = (WIMPFOBJ *)(p->Hdr.Next);
	}
}

/****************************************************************************/
/*!
 *	@brief	󂢂Ă郁ubN擾.
 *
 *	@param	[in]	mpf		Œ蒷v[IuWFNg̃|C^.
 *	@param	[in]	tskid	擾^XNID.
 *
 *	@retval	擾ubÑ|C^.
 */
static BYTE	*GetFreeMem( WIMPFOBJ *mpf, INT tskid )
{
	WIHDR *blk,*ptr;

	if( !mpf->FreeQue ){
		return NULL;
	}
	//! ݂oubN𖢎gpubNL[̐擪o.
	blk = mpf->FreeQue;

	//! gpubNL[̐擪݂oubN폜.
	mpf->FreeQue = mpf->FreeQue->Next;

	//! ݂oubNL[ɑ݂oubNǉ.
	if( !mpf->UsedQue ){
		mpf->UsedQue = blk;
	}else{
		for( ptr = mpf->UsedQue; ptr->Next; ptr = ptr->Next ) ;
		ptr->Next = blk;
	}
	blk->Next = NULL;
	blk->Id   = tskid;

	//! ݂oubN烊Nwb_폜.
	return (BYTE *)((DWORD)blk + sizeof(WIHDR));
}

/****************************************************************************/
/*!
 *	@brief	ubNԋpċ󂫃ubNɂ.
 *
 *	@param	[in]	mpf		Œ蒷v[IuWFNg̃|C^.
 *	@param	[in]	blk		ԋp郁ubÑ|C^.
 *
 *	@retval	Ȃ.
 */
static void		ReleaseFreeMem( WIMPFOBJ *mpf, WIHDR* blk )
{
	WIHDR *ptr;

	//! gpubNL[ɕԋpꂽubNǉ.
	if( !mpf->FreeQue ){
		mpf->FreeQue = blk;
	}else{
		for( ptr = mpf->FreeQue; ptr->Next; ptr = ptr->Next ) ;
		ptr->Next = blk;
	}
	//! ݂õubNL[ԋpꂽubN폜.
	if( mpf->UsedQue == blk ){
		mpf->UsedQue  = blk->Next;
	}else{
		ptr = mpf->UsedQue;
		while( ptr ){
			if( ptr->Next == blk ){
				ptr->Next = blk->Next;
				break;
			}
			ptr = ptr->Next;
		}
	}
	//! ԋpꂽubÑN|C^NA.
	blk->Next = NULL;
	blk->Id   = 0;
}

/****************************************************************************/
/*!
 *	@brief	ubNl҂Ă^XNɃ݂o.
 *
 *	@param	[in]	mpf		Œ蒷v[IuWFNg̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		MemAllocWaitTask( WIMPFOBJ *mpf )
{
	WITSKOBJ *tsk;

	tsk = (WITSKOBJ *)mpf->WaitQue;
	while( tsk ){
		//! 󂢂Ă郁ubN擾.
		tsk->Param[0] = GetFreeMem( mpf, tsk->Hdr.Id );
		if( !tsk->Param[0] ){
			break;
		}
		//! X[vĂ^XNN.
		wi_TaskWakeup( tsk->Hdr.Id, TTW_MPF, NULL );

		//! ҂s񂩂玟̃^XNo.
		tsk = tsk->QueLink;
	}
}

/* End of file */
