/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_semaphore.c
 *
 *	@brief	Windows iTRONT[rXR[ (Z}tH).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <process.h>
#include "wi_semaphore.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;			//!< Z}tHXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	Z}tHǗ̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitSemaphore( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	Z}tHǗ̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitSemaphore( void )
{
	WIHDR		*next_ptr;
	WISEMOBJ	*p = (WISEMOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! Z}tH\̂.
		SAFE_RELEASE( p );

		//! ̃Z}tH\̂o.
		p = (WISEMOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̐.
 *
 *	@param	[in]	id		Z}tHIDԍ.
 *	@param	[in]	obj		Z}tH\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateSemaphore( INT id, const WISEMOBJ *obj )
{
	ER			ercd;
	WISEMOBJ	*p;

	//! sȏꍇ̓G[ɂ.
	if( obj->SemCnt > obj->MaxCnt || obj->MaxCnt == 0 ){
		return E_PAR;
	}
	//! Z}tHIuWFNg쐬.
	p = (WISEMOBJ *)wi_CreateObject( id, TMAX_MAXSEM, sizeof(WISEMOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɃZ}tHǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̍폜.
 *
 *	@param	[in]	id		Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteSemaphore( INT id )
{
	ER			ercd;
	WISEMOBJ	*p;

	//! Z}tHID̃IuWFNg擾.
	p = (WISEMOBJ *)wi_FindObject( id, TMAX_MAXSEM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgYZ}tH菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! Z}tHIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̕ԋp.
 *
 *	@param	[in]	id		Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_SignalSemaphore( INT id )
{
	ER			ercd;
	WISEMOBJ	*p;

	//! Z}tHID̃IuWFNg擾.
	p = (WISEMOBJ *)wi_FindObject( id, TMAX_MAXSEM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! Z}tHJEg+1.
	if( p->SemCnt < p->MaxCnt ){
		p->SemCnt++;
	}
	//! Z}tH̊l҂Ă^XNꍇ̓^XNN.
	if( p->WaitQue ){
		wi_TaskWakeup( p->WaitQue->Id, TTW_SEM, &(p->WaitQue) );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l.
 *
 *	@param	[in]	id		Z}tHIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_WaitSemaphore( INT id, TMO tmout )
{
	ER			ercd;
	WISEMOBJ	*p;

	//! Z}tHID̃IuWFNg擾.
	p = (WISEMOBJ *)wi_FindObject( id, TMAX_MAXSEM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! Z}tHJE^0łȂ΁AZ}tHlďI.
	if( p->SemCnt > 0 ){
		p->SemCnt--;
		return E_OK;
	}
	//! Z}tHԋp܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_SEM, tmout, p->Attribute, &(p->WaitQue) );
	if( ercd == E_OK ){
		if( p->SemCnt > 0 ){
			p->SemCnt--;
		}
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tHԂ̎Q.
 *
 *	@param	[in]	id		Z}tHIDԍ.
 *	@param	[in]	sts		Z}tHԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceSemaphore( INT id, WISEMSTAT *sts )
{
	ER			ercd;
	WISEMOBJ	*p;

	//! Z}tHID̃IuWFNg擾.
	p = (WISEMOBJ *)wi_FindObject( id, TMAX_MAXSEM, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! Z}tH̏Ԃ\̂ɃZbg.
	sts->WaitId  = wi_GetWaitTaskListFirstId( p->WaitQue );
	sts->SemCnt  = p->SemCnt;
	sts->ExtInfo = p->ExtInfo;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseSemaphore( INT id )
{
	WISEMOBJ *p;

	for( p = (WISEMOBJ *)ObjList; p; p = (WISEMOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );
	}
}

/* End of file */
