/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_variable_mempool.c
 *
 *	@brief	Windows iTRONT[rXR[ (ϒv[).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_variable_mempool.h"

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief ϒubÑwb_\.
 *
 */
typedef struct {
	INT		Size;		//!< ubÑTCY (ŏʃrbg=1̂Ƃ݂o).
	DWORD	TaskId;		//!< ubN݂o^XNID.
} MEMHDR;

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static BYTE		*AllocVerMem( INT len, BYTE* buf, INT max_size, DWORD tskid );
static BOOL		FreeVarMem( BYTE* adr, BYTE* buf, INT max_size );
static INT		GetFreeBufSize( INT *max_free, BYTE* buf, INT max_size );
static void		MemAllocWaitTask( WIMPLOBJ *mpl );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR		*ObjList;		//!< ϒv[Xg̃|C^.

/****************************************************************************/
/*!
 *	@brief	ϒv[̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitVarMemPool( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitVarMemPool( void )
{
	WIHDR		*next_ptr;
	WIMPLOBJ	*p = (WIMPLOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! obt@.
		SAFE_RELEASE( p->MemBuf );

		//! ϒv[IuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃v[IuWFNg\̂o.
		p = (WIMPLOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̐.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[in]	obj		ϒv[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateVarMemPool( INT id, const WIMPLOBJ *obj )
{
	ER			ercd;
	MEMHDR		*hdr;
	WIMPLOBJ	*p;

	//! sȏꍇ̓G[ɂ.
	if( obj->MemSize <= 0 ){
		return E_PAR;
	}
	//! ϒv[IuWFNg쐬.
	p = (WIMPLOBJ *)wi_CreateObject( id, TMAX_MAXMPL, sizeof(WIMPLOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! v[̃obt@mۂ.
	p->MemBuf = (BYTE*)malloc( obj->MemSize );
	if( !p->MemBuf ){
		SAFE_RELEASE( p );
		return E_NOMEM;
	}
	//! mۂobt@NA.
	memset( p->MemBuf, 0, obj->MemSize );

	//! obt@̐擪ɃubNwb_t.
	hdr         = (MEMHDR *)p->MemBuf;
	hdr->Size   = obj->MemSize;
	hdr->TaskId = 0;

	//! Xgɉϒv[ǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̍폜.
 *
 *	@param	[in]	id		v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteVarMemPool( INT id )
{
	ER			ercd;
	WIMPLOBJ	*p;

	//! v[ID̃IuWFNg擾.
	p = (WIMPLOBJ *)wi_FindObject( id, TMAX_MAXMPL, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgY郁v[菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! v[̃obt@.
	SAFE_RELEASE( p->MemBuf );

	//! ϒv[IuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[in]	adr		ubÑAhXi[̈̃|C^.
 *	@param	[in]	size	ubÑTCY.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_GetVarMemPool( INT id, VP adr, INT size, TMO tmout )
{
	ER			ercd;
	WITSKOBJ	*tsk;
	WIMPLOBJ	*p;
	BYTE		*blk;

	//! v[ID̃IuWFNg擾.
	p = (WIMPLOBJ *)wi_FindObject( id, TMAX_MAXMPL, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !adr || size <= 0 || size > (INT)(p->MemSize - sizeof(MEMHDR)) ){
		return E_PAR;
	}
	*((BYTE **)adr) = NULL;

	//! ^XNȊǑĂяȍꍇ̓G[ɂ.
	tsk = wi_GetTaskObject( TSK_SELF );
	if( !tsk ){
		return E_CTX;
	}
	//! w肳ꂽTCY̋󂫃mۂ.
	blk = AllocVerMem( size, p->MemBuf, p->MemSize, tsk->Hdr.Id );

	//! mۂłȂꍇ.
	if( !blk ){
		//! KvȃTCY^XNIuWFNgɃZbg.
		tsk->Param[0] = (VP)size;
		tsk->Param[1] = NULL;

		//! ubNԋp܂Ń^XNX[v.
		ercd = wi_TaskWait( id, TTW_MPL, tmout, p->Attribute, &(p->WaitQue) );

		//! G[oƓɃ̊mۂoĂ܂ꍇA͕ԋp.
		if( ercd != E_OK ){
			if( tsk->Param[1] ){
				FreeVarMem( tsk->Param[1], p->MemBuf, p->MemSize );
			}
			return ercd;
		}
		//! ubN̕ԋpŊmۂubÑAhXo.
		blk = (BYTE *)(tsk->Param[1]);
	}
	//! ݂õAhX߂lɊi[.
	*((BYTE **)adr) = blk;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̕ԋp.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[in]	adr		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReleaseVarMemPool( INT id, VP adr )
{
	ER			ercd;
	WIMPLOBJ	*p;

	//! v[ID̃IuWFNg擾.
	p = (WIMPLOBJ *)wi_FindObject( id, TMAX_MAXMPL, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȏꍇ̓G[ɂ.
	if( !adr ){
		return E_PAR;
	}
	//! ԋpꂽubN.
	if( !FreeVarMem( (BYTE*)adr, p->MemBuf, p->MemSize ) ){
		return E_PAR;
	}
	//! ubNl҂̃^XNꍇAmۂ.
	MemAllocWaitTask( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̎Q.
 *
 *	@param	[in]	id		v[IDԍ.
 *	@param	[out]	sts		v[Ԃi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceVarMemPool( INT id, WIMPLSTAT *sts )
{
	ER			ercd;
	WIMPLOBJ	*p;
	INT			total_free,max_free;

	//! v[ID̃IuWFNg擾.
	p = (WIMPLOBJ *)wi_FindObject( id, TMAX_MAXMPL, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! 󂫃̃TCY擾.
	total_free = GetFreeBufSize( &max_free, p->MemBuf, p->MemSize );

	//! ϒv[̏Ԃ\̂ɃZbg.
	sts->WaitId        = wi_GetWaitTaskListFirstId( p->WaitQue );
	sts->TotalFreeSize = total_free;
	sts->MaxFreeSize   = max_free;
	sts->ExtInfo       = p->ExtInfo;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XNmۂubN.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseVarMemPool( INT id )
{
	WIMPLOBJ *p = (WIMPLOBJ *)ObjList;

	while( p ){
		INT		i,j;
		MEMHDR	*hdr1,*hdr2;

		//! 폜^XNɑ݂oĂubNSĉ.
		for( i = 0; i < p->MemSize; ){

			//! obt@烁ubÑwb_o.
			hdr1 = (MEMHDR *)(&p->MemBuf[i]);

			//! ubN󂫃ubNɂ.
			if( hdr1->TaskId == id ){
				hdr1->TaskId = 0;
			}
			//! ̃ubNo.
			i += hdr1->Size;
		}
		//! אڂ󂫃ubN.
		for( i = 0; i < p->MemSize; ){

			//! obt@烁ubÑwb_o.
			hdr1 = (MEMHDR *)(&p->MemBuf[i]);

			/*!
			 * 󂫃ubN̏ꍇÃubN󂫃ubN̂Ƃ
			 * ubN1ɂ.
			 */
			if( hdr1->TaskId == 0 ){
				j = i + hdr1->Size;
				if( j < (p->MemSize - (signed)sizeof(MEMHDR)) ){
					hdr2 = (MEMHDR *)(&p->MemBuf[j]);
					if( hdr2->TaskId == 0 ){
						hdr1->Size += hdr2->Size;
						continue;
					}
				}
			}
			//! ubNȂƂ͎̃ubNo.
			i += hdr1->Size;
		}
		//! ҂s񂩂ł^XN폜.
		p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );

		//! ubNl҂̃^XNꍇ́A󂫃̊mۂɍĒ킷.
		MemAllocWaitTask( p );

		//! ̃v[\̂o.
		p = (WIMPLOBJ *)(p->Hdr.Next);
	}
}

/****************************************************************************/
/*!
 *	@brief	w肵TCỸubN擾.
 *
 *	@param	[in]	len			擾郁ubÑTCY.
 *	@param	[in]	buf			obt@̃|C^.
 *	@param	[in]	max_size	obt@̃TCY.
 *	@param	[in]	tskid		擾^XNID.
 *
 *	@retval	擾ubÑ|C^.
 */
static BYTE	*AllocVerMem( INT len, BYTE* buf, INT max_size, DWORD tskid )
{
	MEMHDR	*hdr;
	INT		i,req_size,remain;

	//! 擾TCYɃwb_TCYĕKvȃTCYvZ.
	req_size = len + sizeof(MEMHDR);

	for( i = 0; i < max_size; ){

		//! obt@烁ubÑwb_o.
		hdr = (MEMHDR *)(&buf[i]);

		if( hdr->TaskId == 0 ){
			if( hdr->Size >= req_size ){
				//! 󂫃ubÑTCYKvȃTCY]vZĂ.
				remain = hdr->Size - req_size;

				//! 󂫃ubNu݂ovɂ.
				hdr->Size   = req_size;
				hdr->TaskId = tskid;

				if( remain > sizeof(MEMHDR) ){
					//! 󂫃ubNɗ]肪ꍇ̓ubN𕪊ė]̋󂫃ubN쐬.
					hdr         = (MEMHDR *)(&buf[i+req_size]);
					hdr->Size   = remain;
					hdr->TaskId = 0;
				}else{
					//! ]肪wb_TCYȉ̏ꍇA݂oTCYɗ]Ă.
					hdr->Size += remain;
				}
				//! ߂l͎gp\͋󂫃ubN̐擪AhXԂ.
				return &buf[i + sizeof(MEMHDR)];
			}
		}
		//! ̃ubNo.
		i += hdr->Size;
	}
	return NULL;
}

/****************************************************************************/
/*!
 *	@brief	ubNԋpċ󂫃ubNɂ.
 *
 *	@param	[in]	adr			ԋp郁ubÑ|C^.
 *	@param	[in]	buf			obt@̃|C^.
 *	@param	[in]	max_size	obt@̃TCY.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		FreeVarMem( BYTE* adr, BYTE* buf, INT max_size )
{
	MEMHDR	*hdr1,*hdr2,*hdr3;
	INT		i,j,pos;

	//! ԋp郁ubÑobt@̈ʒuvZ.
	pos = ((INT)adr - (INT)buf) - (INT)sizeof(MEMHDR);

	//! ԋp郁ubNobt@͈̔͊Ȍꍇ̓G[ɂ.
	if( pos < 0 || pos >= (max_size - (INT)sizeof(MEMHDR)) ){
		return FALSE;
	}
	//! ubN̐擪烊NHāAԋp郁ubNT.
	hdr1 = NULL;
	for( i = 0; i < max_size && i <= pos; ){

		//! obt@烁ubÑwb_o.
		hdr2 = (MEMHDR *)(&buf[i]);

		//! ubÑoCg 0 ̏ꍇAobt@󂳂Ă̂ŏ𒆒f.
		if( hdr2->Size == 0 ){
			break;
		}
		if( i == pos ){
			//! ԋpubN󂫃ubN̏ꍇ̓G[ɂ.
			if( hdr2->TaskId == 0 ){
				break;
			}
			//! ubN󂫃ubNɂ.
			hdr2->TaskId = 0;

			/*!
			 * ̃ubN󂫃ubN̏ꍇAԋpubNƌ
			 * ̃ubNł.
			 */
			j = i + hdr2->Size;
			if( j < (max_size - (INT)sizeof(MEMHDR)) ){
				hdr3 = (MEMHDR *)(&buf[j]);
				if( hdr3->TaskId == 0 ){
					hdr2->Size += hdr3->Size;
				}
			}
			/*!
			 * 1ÕubN󂫃ubN̏ꍇAԋpubNƌ
			 * ԋpubNł.
			 */
			if( hdr1 && hdr1->TaskId == 0 ){
				hdr1->Size += hdr2->Size;
			}
			return TRUE;
		}
		//! ̃ubNo.
		i += hdr2->Size;

		//! 1ÕubÑwb_ʒuXV.
		hdr1 = hdr2;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	󂫃obt@̃TCY擾.
 *
 *	@param	[out]	max_free	ő̘A󂫗̈̃TCYi[̈̃|C^.
 *	@param	[in]	buf			obt@̃|C^.
 *	@param	[in]	max_size	obt@̃TCY.
 *
 *	@retval	󂫗̈̍vTCY.
 */
static INT	GetFreeBufSize( INT *max_free, BYTE* buf, INT max_size )
{
	MEMHDR	*hdr;
	INT		i,total_free;

	*max_free  = 0;
	total_free = 0;

	for( i = 0; i < max_size; ){

		//! obt@烁ubÑwb_o.
		hdr = (MEMHDR *)(&buf[i]);

		//! 󂫃ubN̏ꍇ.
		if( hdr->TaskId == 0 ){
			//! 傫ȋ󂫃ubNꍇATCYۑ.
			if( *max_free < hdr->Size ){
				*max_free = hdr->Size;
			}
			/*!
			 * 󂫃̍vTCYɋ󂫃ubÑTCYZ.
			 * (ubÑwb_TCY͋󂫃TCYɊ܂߂Ȃ)
			 */
			total_free += (hdr->Size - sizeof(MEMHDR));
		}
		//! ̃ubNo.
		i += hdr->Size;
	}
	//! ő̘A󂫗̈̃TCY烁ubÑwb_TCY.
	if( *max_free != 0 ){
		*max_free -= sizeof(MEMHDR);
	}
	return total_free;
}

/****************************************************************************/
/*!
 *	@brief	ubNl҂Ă^XNɃ݂o.
 *
 *	@param	[in]	mpl			ϒv[IuWFNg̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		MemAllocWaitTask( WIMPLOBJ *mpl )
{
	WITSKOBJ *tsk;

	tsk = (WITSKOBJ *)mpl->WaitQue;
	while( tsk ){
		//! w肳ꂽTCY̋󂫃mۂ.
		tsk->Param[1] = AllocVerMem( (INT)(tsk->Param[0]), mpl->MemBuf, mpl->MemSize, tsk->Hdr.Id );
		if( !tsk->Param[1] ){
			break;
		}
		//! X[vĂ^XNN.
		wi_TaskWakeup( tsk->Hdr.Id, TTW_MPL, NULL );

		//! ҂s񂩂玟̃^XNo.
		tsk = tsk->QueLink;
	}
}

/* End of file */
