/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	win_itron3.c
 *
 *	@brief	iTRON(Ver3.0)̃T[rXR[.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <stdio.h>
#include "kprintf.h"
#include "wi_config.h"

#ifdef	__ITRON3__
#include "win_itron3.h"
#include "wi_task.h"
#include "wi_semaphore.h"
#include "wi_event_flag.h"
#include "wi_mail_box.h"
#include "wi_message_buffer.h"
#include "wi_rendezvous_port.h"
#include "wi_fixed_mempool.h"
#include "wi_variable_mempool.h"
#include "wi_cycle_handler.h"
#include "wi_alarm_handler.h"
#include "wi_systemmgr.h"
#include "wi_interrupt.h"

/***************************************
 *
 * ^XNǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	^XN̐.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	pk_ctsk	^XN\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_tsk( ID tskid, const T_CTSK *pk_ctsk )
{
	ER			ercd;
	WITSKOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ctsk ){
		return E_PAR;
	}
	//! ^XNRs[.
	memset( &obj, 0, sizeof(WITSKOBJ) );
	obj.TaskAtr   = pk_ctsk->tskatr;
	obj.TaskAdr   = pk_ctsk->task;
	obj.TaskPri   = pk_ctsk->itskpri;
	obj.InitPri   = pk_ctsk->itskpri;
	obj.StackSize = pk_ctsk->stksz;
	obj.ExtInfo   = pk_ctsk->exinf;

	wi_CommonLock();

	//! ^XN𐶐.
	ercd = wi_CreateTask( tskid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̍폜.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN폜.
	ercd = wi_DeleteTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	stacd	^XNNR[h.
 *
 *	@retval	G[R[h.
 */
ER		sta_tsk( ID tskid, VP_INT stacd )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN.
	ercd = wi_StartTask( tskid, (DWORD)stacd, TRUE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	ext_tsk( void )
{
	//! ^XNI.
	wi_ExitTask();
}

/****************************************************************************/
/*!
 *	@brief	^XN̏Iƍ폜.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	exd_tsk( void )
{
	//! ^XNIăReLXg폜.
	wi_ExpendTask();
}

/****************************************************************************/
/*!
 *	@brief	^XN̋I.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ter_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNI.
	ercd = wi_TermTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XNDx̕ύX.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *	@param	[in]	tskpri	^XNDx.
 *
 *	@retval	G[R[h.
 */
ER		chg_pri( ID tskid, PRI tskpri )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̗DxύX.
	ercd = wi_ChangeTaskPriority( tskid, tskpri );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̏ԎQ.
 *
 *	@param	[in]	pk_rtsk	^XNԂi[̈̃|C^.
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_tsk( T_RTSK *pk_rtsk, ID tskid )
{
	ER			ercd;
	WITSKSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rtsk ){
		return E_PAR;
	}
	wi_CommonLock();

	//! 擾^XN̗̂߂lƂč\̂ɃZbg.
	ercd = wi_RefarenceTask( tskid, &sts );
	if( ercd == E_OK ){
		pk_rtsk->exinf   = sts.ExtInfo;
		pk_rtsk->tskpri  = sts.TaskPri;
		pk_rtsk->tskstat = sts.TaskState;
		pk_rtsk->tskwait = sts.EventType;
		pk_rtsk->wid     = sts.WaitId;
		pk_rtsk->wupcnt  = sts.WakeupCnt;
		pk_rtsk->suscnt  = sts.SuspendCnt;
		pk_rtsk->tskatr  = sts.TaskAtr;
		pk_rtsk->task    = sts.TaskAdr;
		pk_rtsk->itskpri = sts.InitPri;
		pk_rtsk->stksz   = sts.StackSize;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ^XNt@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	N҂ (^CAEgȂ).
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		slp_tsk( void )
{
	//! ^CAEgȂŃ^XNN҂ɂ.
	return tslp_tsk( TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	N҂ (^CAEg).
 *
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tslp_tsk( TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN҂ɂ.
	ercd = wi_SleepTask( tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋N.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wup_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNN.
	ercd = wi_WakeupTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̋Nv𖳌.
 *
 *	@param	[in]	p_wupcnt	L[COĂNv񐔂i[̈̃|C^.
 *	@param	[in]	tskid		^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		can_wup( INT *p_wupcnt, ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XNւ̋NvNA.
	ercd = wi_CancelWakeup( tskid, p_wupcnt );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rel_wai( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̑҂ԂIɉ.
	ercd = wi_ReleaseWait( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃւ̈ڍs.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sus_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN𒆒f(҂)ɂ.
	ercd = wi_SuspendTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	҂Ԃ̍ĊJ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rsm_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN҂ԂĊJ.
	ercd = wi_ResumeTask( tskid );

	wi_CommonUnlock();
	return ercd;
}


/****************************************************************************/
/*!
 *	@brief	҂Ԃ̋ĊJ.
 *
 *	@param	[in]	tskid	^XNIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		frsm_tsk( ID tskid )
{
	ER ercd;

	wi_CommonLock();

	//! ҂Ă^XNIɍĊJ.
	ercd = wi_ForceResumeTask( tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	^XN̒x.
 *
 *	@param	[in]	dlytim	x.
 *
 *	@retval	G[R[h.
 */
ER		dly_tsk( DLYTIME dlytim )
{
	ER	ercd;

	wi_CommonLock();

	ercd = wi_DelayTask( (TMO)dlytim );

	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ (Z}tH).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	Z}tH̐.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *	@param	[in]	pk_csem	Z}tH\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_sem( ID semid, const T_CSEM *pk_csem )
{
	ER			ercd;
	WISEMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_csem ){
		return E_PAR;
	}
	//! Z}tHRs[.
	memset( &obj, 0, sizeof(WISEMOBJ) );
	obj.Attribute = pk_csem->sematr;
	obj.SemCnt    = pk_csem->isemcnt;
	obj.MaxCnt    = pk_csem->maxsem;
	obj.ExtInfo   = pk_csem->exinf;

	wi_CommonLock();

	//! Z}tH𐶐.
	ercd = wi_CreateSemaphore( semid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̍폜.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_sem( ID semid )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH폜.
	ercd = wi_DeleteSemaphore( semid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̕ԋp.
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		sig_sem( ID semid )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH̎ԋp.
	ercd = wi_SignalSemaphore( semid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (^CAEgȂ).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wai_sem( ID semid )
{
	//! ^CAEgȂŃZ}tHl.
	return twai_sem( semid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (|[O).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		pol_sem( ID semid )
{
	//! l҂ȂŃZ}tHl.
	return twai_sem( semid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	Z}tH̊l (^CAEg).
 *
 *	@param	[in]	semid	Z}tHIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		twai_sem( ID semid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Z}tH̎l.
	ercd = wi_WaitSemaphore( semid, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Z}tHԂ̎Q.
 *
 *	@param	[out]	pk_rsem	Z}tHԂi[\̂̃|C^.
 *	@param	[in]	semid	Z}tHIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_sem( T_RSEM *pk_rsem, ID semid )
{
	ER			ercd;
	WISEMSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rsem ){
		return E_PAR;
	}
	wi_CommonLock();

	//! Z}tH̏Ԃ擾.
	ercd = wi_RefarenceSemaphore( semid, &sts );
	if( ercd == E_OK ){
		pk_rsem->exinf  = sts.ExtInfo;
		pk_rsem->wtsk   = sts.WaitId;
		pk_rsem->semcnt = sts.SemCnt;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ (CxgtO).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	CxgtO̐.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	pk_cflg	CxgtO\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_flg( ID flgid, const T_CFLG *pk_cflg )
{
	ER			ercd;
	WIFLGOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cflg ){
		return E_PAR;
	}
	//! CxgtORs[.
	memset( &obj, 0, sizeof(WIFLGOBJ) );
	obj.Attribute = pk_cflg->flgatr & ~TA_CLR;
	obj.FlgVal    = pk_cflg->iflgptn;
	obj.ExtInfo   = pk_cflg->exinf;

	wi_CommonLock();

	//! CxgtO𐶐.
	ercd = wi_CreateEvFlag( flgid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO̍폜.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_flg( ID flgid )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtO폜.
	ercd = wi_DeleteEvFlag( flgid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕZbg.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	setptn	Zbgrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		set_flg( ID flgid, UINT setptn )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtOZbg.
	ercd = wi_SetEvFlag( flgid, setptn );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtÕNA.
 *
 *	@param	[in]	flgid	CxgtOIDԍ.
 *	@param	[in]	clrptn	NArbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		clr_flg( ID flgid, UINT clrptn )
{
	ER ercd;

	wi_CommonLock();

	//! CxgtONA.
	ercd = wi_ClearEvFlag( flgid, clrptn );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (^CAEgȂ).
 *
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *
 *	@retval	G[R[h.
 */
ER		wai_flg( UINT *p_flgptn, ID flgid, UINT waiptn, UINT wfmode )
{
	//! ^CAEgȂŃCxg҂.
	return twai_flg( p_flgptn, flgid, waiptn, wfmode, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (|[O).
 *
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *
 *	@retval	G[R[h.
 */
ER		pol_flg( UINT *p_flgptn, ID flgid, UINT waiptn, UINT wfmode )
{
	//! CxgĂ邩ǂ𒲂ׂ.
	return twai_flg( p_flgptn, flgid, waiptn, wfmode, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	CxgtO҂ (^CAEg).
 *
 *	@param	[out]	p_flgptn	҂̃rbgp^[i[̈̃|C^.
 *	@param	[in]	flgid		CxgtOIDԍ.
 *	@param	[in]	waiptn		҂rbgp^[.
 *	@param	[in]	wfmode		҂[h.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		twai_flg( UINT *p_flgptn, ID flgid, UINT waiptn, UINT wfmode, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Cxg҂.
	ercd = wi_WaitEvFlag( flgid, p_flgptn, waiptn, wfmode, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CxgtOԂ̎Q.
 *
 *	@param	[out]	pk_rflg	CxgtOԂi[\̂̃|C^.
 *	@param	[in]	flgid	CxgtOIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_flg( T_RFLG *pk_rflg, ID flgid )
{
	ER			ercd;
	WIFLGSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rflg ){
		return E_PAR;
	}
	wi_CommonLock();

	//! CxgtȌԂ擾.
	ercd = wi_RefarenceEvFlag( flgid, &sts );
	if( ercd == E_OK ){
		pk_rflg->exinf  = sts.ExtInfo;
		pk_rflg->wtsk   = (BOOL_ID)sts.WaitId;
		pk_rflg->flgptn = sts.FlgVal;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ʐM@\ ([{bNX).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	[{bNX̐.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[in]	pk_cmbx	[{bNX\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mbx( ID mbxid, const T_CMBX *pk_cmbx )
{
	ER			ercd;
	WIMBXOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbx ){
		return E_PAR;
	}
	//! [{bNXRs[.
	memset( &obj, 0, sizeof(WIMBXOBJ) );
	obj.Attribute   = pk_cmbx->mbxatr;
	obj.ExtInfo     = pk_cmbx->exinf;
	obj.MaxPriority = TMAX_MPRI;

	wi_CommonLock();

	//! [{bNX𐶐.
	ercd = wi_CreateMailBox( mbxid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̍폜.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mbx( ID mbxid )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNX폜.
	ercd = wi_DeleteMailBox( mbxid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNXւ̑M.
 *
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[in]	pk_msg	bZ[WpPbg̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		snd_msg( ID mbxid, T_MSG *pk_msg )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNXփbZ[W𑗐M.
	ercd = wi_SendMailBox( mbxid, pk_msg );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (^CAEgȂ).
 *
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rcv_msg( T_MSG **ppk_msg, ID mbxid )
{
	//! ^CAEgȂŃ[{bNX烁bZ[WM.
	return trcv_msg( ppk_msg, mbxid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (|[O).
 *
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		prcv_msg( T_MSG **ppk_msg, ID mbxid )
{
	//! M҂ȂŃ[{bNX烁bZ[WM.
	return trcv_msg( ppk_msg, mbxid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M (^CAEg).
 *
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		trcv_msg( T_MSG **ppk_msg, ID mbxid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! [{bNX烁bZ[WM.
	ercd = wi_ReceiveMailBox( mbxid, ppk_msg, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̏ԎQ.
 *
 *	@param	[out]	pk_rmbx	[{bNXԂi[\̂̃|C^.
 *	@param	[in]	mbxid	[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_mbx( T_RMBX *pk_rmbx, ID mbxid )
{
	ER			ercd;
	WIMBXSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmbx ){
		return E_PAR;
	}
	wi_CommonLock();

	//! [{bNX̏Ԃ擾.
	ercd = wi_RefarenceMailBox( mbxid, &sts );
	if( ercd == E_OK ){
		pk_rmbx->exinf  = sts.ExtInfo;
		pk_rmbx->wtsk   = (BOOL_ID)sts.WaitId;
		pk_rmbx->pk_msg = sts.NextMsg;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * gʐM@\ (bZ[Wobt@).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̐.
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	pk_cmbf	bZ[Wobt@\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mbf( ID mbfid, const T_CMBF *pk_cmbf )
{
	ER			ercd;
	WIMBFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmbf ){
		return E_PAR;
	}
	//! bZ[Wobt@Rs[.
	memset( &obj, 0, sizeof(WIMBFOBJ) );
	obj.SndAttr = pk_cmbf->mbfatr & ~TA_TPRI;
	obj.RcvAttr = pk_cmbf->mbfatr;
	obj.MsgSize = pk_cmbf->bufsz;
	obj.MaxMsg  = pk_cmbf->maxmsz;
	obj.ExtInfo = pk_cmbf->exinf;

	wi_CommonLock();

	//! bZ[Wobt@𐶐.
	ercd = wi_CreateMsgBuffer( mbfid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̍폜.
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mbf( ID mbfid )
{
	ER ercd;

	wi_CommonLock();

	//! bZ[Wobt@폜.
	ercd = wi_DeleteMsgBuffer( mbfid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (^CAEgȂ).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		snd_mbf( ID mbfid, VP msg, INT msgsz )
{
	//! ^CAEgȂŃbZ[Wobt@փbZ[W𑗐M.
	return tsnd_mbf( mbfid, msg, msgsz, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (|[O).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		psnd_mbf( ID mbfid, VP msg, INT msgsz )
{
	//! M҂ȂŃbZ[Wobt@փbZ[W𑗐M.
	return tsnd_mbf( mbfid, msg, msgsz, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@ւ̑M (^CAEg).
 *
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	msg		bZ[W̃|C^.
 *	@param	[in]	msgsz	bZ[W̃TCY.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tsnd_mbf( ID mbfid, VP msg, INT msgsz, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! bZ[Wobt@փbZ[W𑗐M.
	ercd = wi_SendMsgBuffer( mbfid, msg, msgsz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (^CAEgȂ).
 *
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *	@param	[out]	msg		bZ[WTCYi[̈̃|C^.
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		rcv_mbf( VP msg, INT *p_msgsz, ID mbfid )
{
	//! ^CAEgȂŃbZ[Wobt@烁bZ[WM.
	return trcv_mbf( msg, p_msgsz, mbfid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (|[O).
 *
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *	@param	[out]	msg		bZ[WTCYi[̈̃|C^.
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		prcv_mbf( VP msg, INT *p_msgsz, ID mbfid )
{
	//! M҂ȂŃbZ[Wobt@烁bZ[WM.
	return trcv_mbf( msg, p_msgsz, mbfid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̎M (^CAEg).
 *
 *	@param	[out]	msg		bZ[Wi[̈̃|C^.
 *	@param	[out]	msg		bZ[WTCYi[̈̃|C^.
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		trcv_mbf( VP msg, INT *p_msgsz, ID mbfid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! bZ[Wobt@烁bZ[WM.
	ercd = wi_ReceiveMsgBuffer( mbfid, msg, p_msgsz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	bZ[Wobt@̏ԎQ.
 *
 *	@param	[out]	pk_rmbf	bZ[Wobt@Ԃi[\̂̃|C^.
 *	@param	[in]	mbfid	bZ[Wobt@IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_mbf( T_RMBF *pk_rmbf, ID mbfid )
{
	ER			ercd;
	WIMBFSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmbf ){
		return E_PAR;
	}
	wi_CommonLock();

	//! bZ[Wobt@̏Ԃ擾.
	ercd = wi_RefarenceMsgBuffer( mbfid, &sts );
	if( ercd == E_OK ){
		pk_rmbf->exinf   = sts.ExtInfo;
		pk_rmbf->wtsk    = (BOOL_ID)sts.RcvWaitId;
		pk_rmbf->stsk    = (BOOL_ID)sts.SndWaitId;
		pk_rmbf->msgsz   = sts.MsgSize;
		pk_rmbf->frbufsz = sts.FreeSize;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * gʐM@\ (fu).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	fu|[g̐.
 *
 *	@param	[in]	porid	fu|[gIDԍ.
 *	@param	[in]	pk_cpor	fu|[g\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_por( ID porid, const T_CPOR *pk_cpor )
{
	ER			ercd;
	WIPOROBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cpor ){
		return E_PAR;
	}
	//! fu|[gRs[.
	memset( &obj, 0, sizeof(WIPOROBJ) );
	obj.Attribute = pk_cpor->poratr;
	obj.MaxCalMsg = pk_cpor->maxcmsz;
	obj.MaxRepMsg = pk_cpor->maxrmsz;
	obj.ExtInfo   = pk_cpor->exinf;

	wi_CommonLock();

	//! fu|[g𐶐.
	ercd = wi_CreateRendPort( porid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu|[g̍폜.
 *
 *	@param	[in]	porid	fu|[gIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_por( ID porid )
{
	ER ercd;

	wi_CommonLock();

	//! fu|[g폜.
	ercd = wi_DeleteRendPort( porid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fuĂяo (^CAEgȂ).
 *
 *	@param	[in]	msg			ĂяobZ[W̃AhX.
 *	@param	[out]	p_rmsgsz	bZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		ĂяoĨrbgp^[.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		cal_por( VP msg, INT *p_rmsgsz, ID porid, UINT calptn, INT cmsgsz )
{
	//! ^CAEgȂŃfuĂяo.
	return tcal_por( msg, p_rmsgsz, porid, calptn, cmsgsz, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	fuĂяo (|[O).
 *
 *	@param	[in]	msg			ĂяobZ[W̃AhX.
 *	@param	[out]	p_rmsgsz	bZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		ĂяoĨrbgp^[.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		pcal_por( VP msg, INT *p_rmsgsz, ID porid, UINT calptn, INT cmsgsz )
{
	//! t҂ȂŃfuĂяo.
	return tcal_por( msg, p_rmsgsz, porid, calptn, cmsgsz, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	fuĂяo (^CAEg).
 *
 *	@param	[in]	msg			ĂяobZ[W̃AhX.
 *	@param	[out]	p_rmsgsz	bZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		ĂяoĨrbgp^[.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tcal_por( VP msg, INT *p_rmsgsz, ID porid, UINT calptn, INT cmsgsz, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! fuĂяo.
	ercd = wi_CallRendPort( porid, calptn, msg, cmsgsz, p_rmsgsz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (^CAEgȂ).
 *
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *	@param	[out]	p_cmsgsz	ĂяobZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		acp_por( RNO *p_rdvno, VP msg, INT *p_cmsgsz, ID porid, UINT acpptn )
{
	//! ^CAEgȂŃfu󂯕t.
	return tacp_por( p_rdvno, msg, p_cmsgsz, porid, acpptn, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (|[O).
 *
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *	@param	[out]	p_cmsgsz	ĂяobZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *
 *	@retval	G[R[h.
 */
ER		pacp_por( RNO *p_rdvno, VP msg, INT *p_cmsgsz, ID porid, UINT acpptn )
{
	//! Ăяo҂ȂŃfu󂯕t.
	return tacp_por( p_rdvno, msg, p_cmsgsz, porid, acpptn, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	fu󂯕t (^CAEg).
 *
 *	@param	[out]	p_rdvno		fuԍi[̈̃|C^.
 *	@param	[out]	msg			ĂяobZ[Wi[̈̃|C^.
 *	@param	[out]	p_cmsgsz	ĂяobZ[W̃TCYi[̈̃|C^.
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	acpptn		󂯕tĨrbgp^[.
 *	@param	[in]	tmout		^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tacp_por( RNO *p_rdvno, VP msg, INT *p_cmsgsz, ID porid, UINT acpptn, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! fu󂯕t.
	ercd = wi_AcceptRendPort( porid, acpptn, p_rdvno, msg, p_cmsgsz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fủ
 *
 *	@param	[in]	porid		fu|[gIDԍ.
 *	@param	[in]	calptn		󂯕tĨrbgp^[.
 *	@param	[in]	rdvno		fuԍ.
 *	@param	[in]	msg			ĂяobZ[W̃|C^.
 *	@param	[in]	cmsgsz		ĂяobZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		fwd_por( ID porid, UINT calptn, RNO rdvno, VP msg, INT cmsgsz )
{
	ER ercd;

	wi_CommonLock();

	//! fu𑼂̃fu|[gɉ񑗂.
	ercd = wi_FowardRendPort( porid, calptn, rdvno, msg, cmsgsz );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fȕI.
 *
 *	@param	[in]	rdvno		fuԍ.
 *	@param	[in]	msg			ԓbZ[W̃|C^.
 *	@param	[in]	cmsgsz		ԓbZ[W̃TCY.
 *
 *	@retval	G[R[h.
 */
ER		rpl_rdv( RNO rdvno, VP msg, INT cmsgsz )
{
	ER ercd;

	wi_CommonLock();

	//! fȕIʒm.
	ercd = wi_ReplayRendPort( rdvno, msg, cmsgsz );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fu|[g̏ԎQ.
 *
 *	@param	[out]	pk_rpor	fu|[gԂi[\̂̃|C^.
 *	@param	[in]	porid	fu|[gIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_por( T_RPOR *pk_rpor, ID porid )
{
	ER			ercd;
	WIPORSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rpor ){
		return E_PAR;
	}
	wi_CommonLock();

	//! fu|[g̏Ԃ擾.
	ercd = wi_RefarenceRendPort( porid, &sts );
	if( ercd == E_OK ){
		pk_rpor->exinf = sts.ExtInfo;
		pk_rpor->wtsk  = (BOOL_ID)sts.CalWaitId;
		pk_rpor->atsk  = (BOOL_ID)sts.AcpWaitId;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * v[Ǘ@\ (Œ蒷v[).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̐.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[in]	pk_cmpf	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mpf( ID mpfid, const T_CMPF *pk_cmpf )
{
	ER			ercd;
	WIMPFOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpf ){
		return E_PAR;
	}
	//! Œ蒷v[Rs[.
	memset( &obj, 0, sizeof(WIMPFOBJ) );
	obj.ExtInfo   = pk_cmpf->exinf;
	obj.Attribute = pk_cmpf->mpfatr;
	obj.BlockCnt  = pk_cmpf->mpfcnt;
	obj.BlockSize = pk_cmpf->blfsz;

	wi_CommonLock();

	//! Œ蒷v[𐶐.
	ercd = wi_CreateFixedMemPool( mpfid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̍폜.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mpf( ID mpfid )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷v[폜.
	ercd = wi_DeleteFixedMemPool( mpfid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (^CAEgȂ).
 *
 *	@param	[in]	p_blf	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		get_blf( VP *p_blf, ID mpfid )
{
	//! ^CAEgȂŌŒ蒷ubNl.
	return tget_blf( p_blf, mpfid, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (|[O).
 *
 *	@param	[in]	p_blf	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		pget_blf( VP *p_blf, ID mpfid )
{
	//! l҂ȂŌŒ蒷ubNl.
	return tget_blf( p_blf, mpfid, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̊l (^CAEg).
 *
 *	@param	[in]	p_blf	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tget_blf( VP *p_blf, ID mpfid, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷ubNl.
	ercd = wi_GetFixedMemPool( mpfid, p_blf, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷ubN̕ԋp.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *	@param	[in]	blf		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		rel_blf( ID mpfid, VP blf )
{
	ER ercd;

	wi_CommonLock();

	//! Œ蒷ubNԋp.
	ercd = wi_ReleaseFixedMemPool( mpfid, blf );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	Œ蒷v[̎Q.
 *
 *	@param	[out]	pk_rmpf	v[Ԃi[\̂̃|C^.
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_mpf( T_RMPF *pk_rmpf, ID mpfid )
{
	ER			ercd;
	WIMPFSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmpf ){
		return E_PAR;
	}
	wi_CommonLock();

	//! Œ蒷v[̏Ԃ擾.
	ercd = wi_RefarenceFixedMemPool( mpfid, &sts );
	if( ercd == E_OK ){
		pk_rmpf->exinf  = sts.ExtInfo;
		pk_rmpf->wtsk   = (BOOL_ID)sts.WaitId;
		pk_rmpf->frbcnt = sts.FreeBlock;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * v[Ǘ@\ (ϒv[).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	ϒv[̐.
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	pk_cmpl	v[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		cre_mpl( ID mplid, const T_CMPL *pk_cmpl )
{
	ER			ercd;
	WIMPLOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_cmpl ){
		return E_PAR;
	}
	//! ϒv[Rs[.
	memset( &obj, 0, sizeof(WIMPLOBJ) );
	obj.ExtInfo   = pk_cmpl->exinf;
	obj.Attribute = pk_cmpl->mplatr;
	obj.MemSize   = pk_cmpl->mplsz;

	wi_CommonLock();

	//! ϒv[𐶐.
	ercd = wi_CreateVarMemPool( mplid, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̍폜.
 *
 *	@param	[in]	mpfid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		del_mpl( ID mplid )
{
	ER ercd;

	wi_CommonLock();

	//! ϒv[폜.
	ercd = wi_DeleteVarMemPool( mplid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (^CAEgȂ).
 *
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *
 *	@retval	G[R[h.
 */
ER		get_blk( VP p_blk, ID mplid, INT blksz )
{
	//! ^CAEgȂŉϒubNl.
	return tget_blk( p_blk, mplid, blksz, TMO_FEVR );
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (|[O).
 *
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *
 *	@retval	G[R[h.
 */
ER		pget_blk( VP p_blk, ID mplid, INT blksz )
{
	//! l҂ȂŉϒubNl.
	return tget_blk( p_blk, mplid, blksz, TMO_POL );
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̊l (^CAEg).
 *
 *	@param	[in]	p_blk	ubÑAhXi[̈̃|C^.
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blksz	ubÑTCY.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		tget_blk( VP p_blk, ID mplid, INT blksz, TMO tmout )
{
	ER ercd;

	wi_CommonLock();

	//! ϒubNl.
	ercd = wi_GetVarMemPool( mplid, p_blk, blksz, tmout );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒubN̕ԋp.
 *
 *	@param	[in]	mplid	v[IDԍ.
 *	@param	[in]	blk		ԋp郁ubÑAhX.
 *
 *	@retval	G[R[h.
 */
ER		rel_blk( ID mplid, VP blk )
{
	ER ercd;

	wi_CommonLock();

	//! ϒubNԋp.
	ercd = wi_ReleaseVarMemPool( mplid, blk );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	ϒv[̎Q.
 *
 *	@param	[out]	pk_rmpl	v[Ԃi[\̂̃|C^.
 *	@param	[in]	mplid	v[IDԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_mpl( T_RMPL *pk_rmpl, ID mplid )
{
	ER			ercd;
	WIMPLSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rmpl ){
		return E_PAR;
	}
	wi_CommonLock();

	//! ϒv[̏Ԃ擾.
	ercd = wi_RefarenceVarMemPool( mplid, &sts );
	if( ercd == E_OK ){
		pk_rmpl->exinf = sts.ExtInfo;
		pk_rmpl->wtsk  = (BOOL_ID)sts.WaitId;
		pk_rmpl->frsz  = sts.TotalFreeSize;
		pk_rmpl->maxsz = sts.MaxFreeSize;
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ԊǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	VXe̐ݒ.
 *
 *	@param	[in]	pk_tim		ݒ肷鎞i[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		set_tim( const SYSTIME *pk_tim )
{
	if( !pk_tim ){
		return E_PAR;
	}
	wi_CommonLock();

	//! VXeݒ肷.
	wi_SetSystemTime( ((DWORDLONG)(pk_tim->utime) << 32) + (DWORDLONG)(pk_tim->ltime) );

	wi_CommonUnlock();
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	VXe̎Q.
 *
 *	@param	[in]	pk_tim		VXei[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_tim( SYSTIME *pk_tim )
{
	DWORDLONG sys_time;

	if( !pk_tim ){
		return E_PAR;
	}
	wi_CommonLock();

	//! VXeQƂ.
	sys_time      = wi_GetSystemTime();
	pk_tim->utime = (short)(sys_time >> 32 & 0x0000FFFF);
	pk_tim->ltime = (long )(sys_time       & 0xFFFFFFFF);

	wi_CommonUnlock();
	return E_OK;
}

/***************************************
 *
 * ԊǗ@\ (nh).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	nh`.
 *
 *	@param	[in]	cycno	nhԍ.
 *	@param	[in]	pk_dcyc	nh`.
 *
 *	@retval	G[R[h.
 */
ER		def_cyc( HNO cycno, const T_DCYC *pk_dcyc )
{
	ER			ercd;
	WICYCOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_dcyc ){
		return E_PAR;
	}
	//! nh`Rs[.
	memset( &obj, 0, sizeof(WICYCOBJ) );
	obj.Attribute = pk_dcyc->cycatr;
	obj.CycAdr    = pk_dcyc->cychdr;
	obj.Active    = (pk_dcyc->cycact & TCY_ON) ? TRUE : FALSE;
	obj.ExtInfo   = pk_dcyc->exinf;
	obj.CycleTime = ((DWORDLONG)(pk_dcyc->cyctim.utime) << 32) + (DWORDLONG)(pk_dcyc->cyctim.ltime);

	wi_CommonLock();

	//! nho^.
	ercd = wi_DefineCycleHadler( cycno, &obj, TRUE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̊.
 *
 *	@param	[in]	cycno	nhԍ.
 *	@param	[in]	cycact	nh.
 *
 *	@retval	G[R[h.
 */
ER		act_cyc( HNO cycno, UINT cycact )
{
	ER ercd;

	wi_CommonLock();

	//! nh̋N/~ݒ肷.
	ercd = wi_ActionCycleHadler( cycno,
								((cycact & TCY_ON ) != 0) ? TRUE : FALSE,
								((cycact & TCY_INI) != 0) ? TRUE : FALSE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	nh̏ԎQ.
 *
 *	@param	[out]	pk_rcyc	nhԂi[\̂̃|C^.
 *	@param	[in]	cycno	nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_cyc( T_RCYC *pk_rcyc, HNO cycno )
{
	ER			ercd;
	WICYCSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_rcyc ){
		return E_PAR;
	}
	wi_CommonLock();

	//! nh̏Ԃ擾.
	ercd = wi_RefarenceCycleHadler( cycno, &sts );
	if( ercd == E_OK ){
		pk_rcyc->exinf        = sts.ExtInfo;
		pk_rcyc->lfttim.utime = (short)(sts.LeftTime >> 32 & 0x0000FFFF);
		pk_rcyc->lfttim.ltime = (long )(sts.LeftTime       & 0xFFFFFFFF);
		pk_rcyc->cycact       = (sts.Active ? TCY_ON : TCY_OFF);
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * ԊǗ@\ (A[nh).
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	A[nh`.
 *
 *	@param	[in]	almno	A[nhԍ.
 *	@param	[in]	pk_dalm	A[nh`.
 *
 *	@retval	G[R[h.
 */
ER		def_alm( HNO almno, const T_DALM *pk_dalm )
{
	ER			ercd;
	WIALMOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_dalm ){
		return E_PAR;
	}
	//! A[nho^Rs[.
	memset( &obj, 0, sizeof(WIALMOBJ) );
	obj.Attribute = pk_dalm->almatr;
	obj.AlmAdr    = pk_dalm->almhdr;
	obj.TimeMode  = pk_dalm->tmmode;
	obj.AlmTime   = ((DWORDLONG)(pk_dalm->almtim.utime) << 32) + (DWORDLONG)(pk_dalm->almtim.ltime);
	obj.ExtInfo   = pk_dalm->exinf;
	obj.Active    = pk_dalm->almhdr ? TRUE : FALSE;

	//! A[nh̋Nݎ̑Ύɂ.
	if( (obj.TimeMode & TTM_REL) != 0 ){
		obj.AlmTime += wi_GetSystemTime();
	}
	wi_CommonLock();

	//! A[nho^.
	ercd = wi_DefineAlarmHadler( almno, &obj, TRUE );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	A[nh̏ԎQ.
 *
 *	@param	[out]	pk_ralm	A[nhԂi[\̂̃|C^.
 *	@param	[in]	almno	A[nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		ref_alm( T_RALM *pk_ralm, HNO almno )
{
	ER			ercd;
	WIALMSTAT	sts;

	//! sȏꍇ̓G[ɂ.
	if( !pk_ralm ){
		return E_PAR;
	}
	wi_CommonLock();

	//! A[nh̏Ԃ擾.
	ercd = wi_RefarenceAlarmHadler( almno, &sts );
	if( ercd == E_OK ){
		pk_ralm->exinf        = sts.ExtInfo;
		pk_ralm->lfttim.utime = (short)(sts.LeftTime >> 32 & 0x0000FFFF);
		pk_ralm->lfttim.ltime = (long )(sts.LeftTime       & 0xFFFFFFFF);
	}
	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * 荞݊Ǘ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	荞݃nh̒`.
 *
 *	@param	[in]	dintno		荞݃nhԍ.
 *	@param	[in]	pk_dint		荞݃nh`\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		def_int( UINT dintno, const T_DINT *pk_dint )
{
	ER			ercd;
	WIINTOBJ	obj;

	//! sȏꍇ̓G[ɂ.
	if( !pk_dint ){
		return E_PAR;
	}
	//! 荞݃nh`Rs[.
	memset( &obj, 0, sizeof(WIINTOBJ) );
	obj.Attribute = pk_dint->intatr;
	obj.IntrAdr   = pk_dint->inthdr;

	wi_CommonLock();

	//! 荞݃nho^.
	ercd = wi_DefineIntrruptHander( dintno, &obj );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋֎~.
 *
 *	@param	[in]	eintno		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		dis_int( UINT eintno )
{
	ER ercd;

	wi_CommonLock();

	//! 荞݂֎~.
	ercd = wi_DisableIntrrupt( eintno );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋.
 *
 *	@param	[in]	eintno		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		ena_int( UINT eintno )
{
	ER ercd;

	wi_CommonLock();

	//! 荞݂.
	ercd = wi_EnableIntrrupt( eintno );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂւ̈ڍs.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		loc_cpu( void )
{
	ER ercd;

	wi_CommonLock();

	//! CPUbN.
	ercd = wi_LockCPU();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂ̉.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		unl_cpu( void )
{
	ER ercd;

	wi_CommonLock();

	//! CPŨbN.
	ercd = wi_UnLockCPU();

	wi_CommonUnlock();
	return ercd;
}

/***************************************
 *
 * VXeԊǗ@\.
 *
 **************************************/
/****************************************************************************/
/*!
 *	@brief	^XN̗D揇ʂ̉].
 *
 *	@param	[in]	tskpri	D揇ʂ]Dx.
 *
 *	@retval	G[R[h.
 */
ER		rot_rdq( PRI tskpri )
{
	ER ercd;

	wi_CommonLock();

	//! ^XN̗D揇ʂ].
	ercd = wi_RotateTaskPriority( tskpri );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	sԂ̃^XNID̎Q.
 *
 *	@param	[out]	p_tskid		^XNIDԍi[̈̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_tid( ID *p_tskid )
{
	ER ercd;

	wi_CommonLock();

	//! sԂɂ^XNID擾.
	ercd = wi_GetTid( p_tskid );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fBXpb`̋֎~.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		dis_dsp( void )
{
	ER ercd;

	wi_CommonLock();

	//! ^XÑfBXpb`֎~.
	ercd = wi_DisabledDispatch();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	fBXpb`̋.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		ena_dsp( void )
{
	ER ercd;

	wi_CommonLock();

	//! ^XÑfBXpb`.
	ercd = wi_EnabledDispatch();

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	VXeԂ̎Q.
 *
 *	@param	[out]	pk_rsys		VXeԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_sys( T_RSYS *pk_rsys )
{
	ER ercd;

	wi_CommonLock();

	//! VXe擾.
	ercd = wi_GetSystemInfo( pk_rsys );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	o[W̎Q.
 *
 *	@param	[out]	pk_ver		o[Wi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		get_ver( T_VER *pk_ver )
{
	ER ercd;

	wi_CommonLock();

	//! o[W擾.
	ercd = wi_GetVersion( pk_ver );

	wi_CommonUnlock();
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	RtBO[V̎Q.
 *
 *	@param	[out]	pk_rcfg		RtBO[Vi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		ref_cfg( T_RCFG *pk_rcfg )
{
	ER ercd;

	wi_CommonLock();

	//! RtBO[V擾.
	ercd = wi_GetConfigInfo( pk_rcfg );

	wi_CommonUnlock();
	return ercd;
}
#endif	// __ITRON3__

/* End of file */
